#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# Copyright 2013 A minha casa digital 
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


##############BIBLIOTECAS A IMPORTAR E DEFINICOES####################

import urllib,urllib2,re,xbmcplugin,xbmcgui,xbmc,xbmcaddon,HTMLParser
h = HTMLParser.HTMLParser()


addon_id = 'plugin.video.TedxPT'
selfAddon = xbmcaddon.Addon(id=addon_id)
addonfolder = selfAddon.getAddonInfo('path')
artfolder = '/resources/img/'
#bitrate = '-1500k.mp4'
qualidade = selfAddon.getSetting('quality')

################################################## 
if  qualidade == '0':
    bitrate = '-320k.mp4'
if qualidade == '1':    
    bitrate = '-450k.mp4'
if qualidade == '2':    
    bitrate = '-600k.mp4'
if qualidade == '3':    
    bitrate = '-950k.mp4'
if qualidade == '4':    
    bitrate = '-1500k.mp4'
#MENUS############################################

def CATEGORIES():
        addDir('Portugues','http://www.ted.com/translate/languages/pt',1,addonfolder + artfolder + 'ted.png')
#        addDir('TedxPortugal','http://tedxtalks.ted.com/browse/talks-by-country/portugal',3,addonfolder + artfolder + 'ted.png')

###################################################################################
#FUNCOES

def listar_videos(url):
    codigo_fonte = abrir_url(url)
        #print codigo_fonte
    match=re.compile('<a title="(.+?)" href="(.+?)"><img class="play_icon" src=".+?" alt="Play_icon" /><img alt=".+?" src="(.+?)" /></a>').findall(codigo_fonte)
    for titulo, url, img in match:
        addDir(titulo,'http://www.ted.com/'+url,2,img,pasta = False)
    match=re.compile('<li class="next"><a href="(.+?)">').findall(codigo_fonte)
    for url_next_page in match:
        addLink('','','')
        addDir('[COLOR red]PAGINA SEGUINTE >>[/COLOR]','http://www.ted.com'+ url_next_page,1,'')

def listar_videos_tedx(url):
    codigo_fonte = abrir_url(url)
        #print codigo_fonte
    match=re.compile('<a href="(.+?)" title="(.+?)">').findall(codigo_fonte)
    for url, titulo in match:
        addDir(titulo,'http://http://tedxtalks.ted.com/'+url,4,'',pasta = False)
    match=re.compile('<a class="mvp-pagenum-next mvp-pagenum-pagelink" href="(.+?)">Next').findall(codigo_fonte)
    for url_next_page in match:
        addLink('','','')
        addDir('[COLOR red]PAGINA SEGUINTE >>[/COLOR]','http://tedxtalks.ted.com/browse/talks-by-country/portugal'+ url_next_page,3,'')

def resolve(url):
    codigo_fonte = abrir_url(url)
    match = re.compile('<a id="no-flash-video-download" href="(.+?)?apikey=TEDDOWNLOAD">').findall(codigo_fonte)
    for ficheiro in match:
       ficheiro = ficheiro.replace('.mp4',bitrate)
    match = re.compile('data-id="(.+?)"').findall(codigo_fonte)
    for legenda in match:
        print legenda
        legendas = "http://tedtalksubtitledownload.appspot.com/get_subtitle?tedtalkid="+legenda+"&lang=pt&timeIntro=11820.82000"
    player_legendas(ficheiro,legendas)
    
def resolve_tedx(url):
    codigo_fonte = abrir_url(url)
    match = re.compile('<a id="no-flash-video-download" href="(.+?)?apikey=TEDDOWNLOAD">').findall(codigo_fonte)
    for ficheiro in match:
       ficheiro = ficheiro.replace('.mp4',bitrate)
    match = re.compile('data-id="(.+?)"').findall(codigo_fonte)
    for legenda in match:
        print legenda
        legendas = "http://tedtalksubtitledownload.appspot.com/get_subtitle?tedtalkid="+legenda+"&lang=pt&timeIntro=11820.82000"
    player_legendas(ficheiro,legendas)
                
def player_legendas(ficheiro,legendas):
    xbmc.Player().play(ficheiro)
    xbmc.sleep(200)
    xbmc.Player().setSubtitles(legendas)
    
    

###################################################################################
#FUNCOES JÃ� FEITAS


def abrir_url(url):
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        response = urllib2.urlopen(req)
        link=response.read()
        response.close()
        return link

def addLink(name,url,iconimage):
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        liz.setProperty('fanart_image', addonfolder + artfolder + 'fanart.png')
        liz.setInfo( type="Video", infoLabels={ "Title": name } )
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=liz)
        return ok

def addDir(name,url,mode,iconimage,pasta = True):
        u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
        ok=True
        liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=pasta)
        return ok

############################################################################################################
#                                               GET PARAMS                                                 #
############################################################################################################
              
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param

      
params=get_params()
url=None
name=None
mode=None
iconimage=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass

try:        
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass


print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "Iconimage: "+str(iconimage)




###############################################################################################################
#                                                   MODOS                                                     #
###############################################################################################################


if mode==None or url==None or len(url)<1:
        print ""
        CATEGORIES()

elif mode==1:
        listar_videos(url)

elif mode==2:
      resolve(url)
      
elif mode==3:
    listar_videos_tedx(url)
    
elif mode==4:
    resolve_tedx(url) 
xbmcplugin.endOfDirectory(int(sys.argv[1]))
